'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectionItem = exports.Selection = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _keys = require('ramda/src/keys');

var _keys2 = _interopRequireDefault(_keys);

var _forEachObjIndexed = require('ramda/src/forEachObjIndexed');

var _forEachObjIndexed2 = _interopRequireDefault(_forEachObjIndexed);

var _isNil = require('ramda/src/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _always = require('ramda/src/always');

var _always2 = _interopRequireDefault(_always);

var _map = require('ramda/src/map');

var _map2 = _interopRequireDefault(_map);

var _ = require('ramda/src/__');

var _2 = _interopRequireDefault(_);

var _reject = require('ramda/src/reject');

var _reject2 = _interopRequireDefault(_reject);

var _compose = require('ramda/src/compose');

var _compose2 = _interopRequireDefault(_compose);

var _equals = require('ramda/src/equals');

var _equals2 = _interopRequireDefault(_equals);

var _cond = require('ramda/src/cond');

var _cond2 = _interopRequireDefault(_cond);

var _is = require('ramda/src/is');

var _is2 = _interopRequireDefault(_is);

var _pair = require('ramda/src/pair');

var _pair2 = _interopRequireDefault(_pair);

var _fromPairs = require('ramda/src/fromPairs');

var _fromPairs2 = _interopRequireDefault(_fromPairs);

var _append = require('ramda/src/append');

var _append2 = _interopRequireDefault(_append);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 *
 *
 *
 *
 * ~~~ Selection
 *
 */
var Selection = function (_Component) {
  _inherits(Selection, _Component);

  function Selection(props) {
    _classCallCheck(this, Selection);

    var _this = _possibleConstructorReturn(this, (Selection.__proto__ || Object.getPrototypeOf(Selection)).call(this, props));

    _this.componentWillMount = function () {
      return _this.selectedChildren = {};
    };

    _this.componentDidMount = function () {
      return _this._selects(_this.props.selects);
    };

    _this.componentWillReceiveProps = function (nextProps) {
      if (!nextProps.enabled) _this.setState({ selectedItems: {} });
      if (_this.props.selects !== nextProps.selects) _this._selects(nextProps.selects);
    };

    _this.componentDidUpdate = function () {
      if (_this.state.mouseDown && !(0, _isNil2.default)(_this.state.selectionBox)) {
        _this._updateCollidingChildren(_this.state.selectionBox);
      }
    };

    _this._selects = function (x) {
      return (0, _cond2.default)([[(0, _equals2.default)(true), _this.selectAll], [(0, _equals2.default)(false), _this.clearSelection], [(0, _is2.default)(Array), _this.selectItems]])(x);
    };

    _this._onMouseDown = function (e) {
      if (!_this.props.enabled || e.button === 2 || e.nativeEvent.which === 2) return;
      var mouseDown = true;
      var appendMode = e.ctrlKey || e.altKey || e.shiftKey;
      var startPoint = { x: e.pageX, y: e.pageY };
      var endPoint = { x: e.pageX, y: e.pageY };
      var selectionBox = _this._calculateSelectionBox(startPoint, endPoint);
      _this.setState({ mouseDown: mouseDown, appendMode: appendMode, startPoint: startPoint, endPoint: endPoint, selectionBox: selectionBox });
      window.document.addEventListener('mousemove', _this._onMouseMove);
      window.document.addEventListener('mouseup', _this._onMouseUp);
    };

    _this._onMouseUp = function (e) {
      window.document.removeEventListener('mousemove', _this._onMouseMove);
      window.document.removeEventListener('mouseup', _this._onMouseUp);
      _this.setState({
        mouseDown: false,
        startPoint: null,
        endPoint: null,
        selectionBox: null,
        appendMode: false
      });
      _this.props.onSelectionChange.call(null, (0, _compose2.default)((0, _reject2.default)((0, _equals2.default)('selectionBox')), _keys2.default)(_this.selectedChildren));
    };

    _this._onMouseMove = function (e) {
      e.preventDefault();
      if (_this.state.mouseDown) {
        var endPoint = {
          x: e.pageX,
          y: e.pageY
        };
        _this.setState({
          endPoint: endPoint,
          selectionBox: _this._calculateSelectionBox(_this.state.startPoint, endPoint)
        });
      }
    };

    _this._boxIntersects = function (boxA, boxB) {
      return _this.props.sensibility < _this.state.selectionBox.width * _this.state.selectionBox.height && boxA.left <= boxB.left + boxB.width && boxA.left + boxA.width >= boxB.left && boxA.top <= boxB.top + boxB.height && boxA.top + boxA.height >= boxB.top;
    };

    _this._updateCollidingChildren = function (selectionBox) {
      var tmpNode = null;
      var tmpBox = null;
      (0, _forEachObjIndexed2.default)(function (ref, key) {
        if (key !== 'selectionBox') {
          tmpNode = _reactDom2.default.findDOMNode(ref);
          tmpBox = {
            top: tmpNode.offsetTop,
            left: tmpNode.offsetLeft,
            width: tmpNode.clientWidth,
            height: tmpNode.clientHeight
          };
          if (_this._boxIntersects(selectionBox, tmpBox)) {
            _this.selectedChildren[key] = true;
          } else if (!_this.state.appendMode) {
            delete _this.selectedChildren[key];
          }
        }
      }, _this.subscribed);
      _this._update();
    };

    _this._update = function () {
      return (0, _forEachObjIndexed2.default)(function (ref, key) {
        ref.setState({ isSelected: !!_this.selectedChildren[key] });
      }, _this.subscribed);
    };

    _this._calculateSelectionBox = function (startPoint, endPoint) {
      var parentNode = _reactDom2.default.findDOMNode(_this.refs.selectionBox);
      var left = Math.min(startPoint.x, endPoint.x) - parentNode.offsetLeft;
      var top = Math.min(startPoint.y, endPoint.y) - parentNode.offsetTop;
      var width = Math.abs(startPoint.x - endPoint.x);
      var height = Math.abs(startPoint.y - endPoint.y);
      return { left: left, top: top, width: width, height: height };
    };

    _this._renderSelectionBox = function () {
      return !_this.state.mouseDown || (0, _isNil2.default)(_this.state.endPoint) || (0, _isNil2.default)(_this.state.startPoint) || _this.props.sensibility > _this.state.selectionBox.width * _this.state.selectionBox.height ? null : _react2.default.createElement('div', { style: _extends({ position: 'absolute', zIndex: 99 }, _this.props.styleSelectionBox, _this.state.selectionBox) });
    };

    _this._subscribe = function (key) {
      return function (ref) {
        if (ref) _this.subscribed[key] = ref;
      };
    };

    _this.render = function () {
      var _this$props = _this.props,
          style = _this$props.style,
          className = _this$props.className,
          others = _objectWithoutProperties(_this$props, ['style', 'className']);

      return _react2.default.createElement(
        'div',
        {
          style: _extends({ position: 'relative' }, style),
          className: className + ' ' + (_this.state.mouseDown && 'dragging'),
          ref: 'selectionBox',
          onMouseDown: _this._onMouseDown
        },
        _this.props.children(_this._subscribe),
        _this._renderSelectionBox()
      );
    };

    _this.selectItems = function (keyArray) {
      _this.selectedChildren = (0, _compose2.default)(_fromPairs2.default, (0, _map2.default)((0, _pair2.default)(_2.default, true)), (0, _append2.default)('selectionBox'))(keyArray);
      _this.props.onSelectionChange.call(null, keyArray);
      _this._update();
    };

    _this.selectItem = function (key) {
      _this.selectItems([key]);
    };

    _this.selectAll = function () {
      (0, _forEachObjIndexed2.default)(function (ref, key) {
        _this.selectedChildren[key] = true;
      }, _this.subscribed);
      _this.props.onSelectionChange.call(null, (0, _compose2.default)((0, _reject2.default)((0, _equals2.default)('selectionBox')), _keys2.default)(_this.selectedChildren));
      _this._update();
    };

    _this.clearSelection = function () {
      _this.selectedChildren = {};
      _this.props.onSelectionChange.call(null, []);
      _this._update();
    };

    _this.state = {
      mouseDown: false,
      startPoint: null,
      endPoint: null,
      selectionBox: null,
      selectedItems: {},
      appendMode: false
    };
    _this.subscribed = {};
    return _this;
  }

  /**
   * Manually update the selection status of an array of items
   * @param {[string]} keyArray the item's target key value
   */


  /**
   * Manually update the selection status of an item
   * @param {string} key the item's target key value
   */


  /**
   * Manually select all items
   */


  /**
   * Manually clear selected items
   */


  return Selection;
}(_react.Component);

Selection.propTypes = {
  enabled: _propTypes2.default.bool,
  onSelectionChange: _propTypes2.default.func,
  selects: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.arrayOf(_propTypes2.default.string)]),
  sensibility: _propTypes2.default.number,
  styleSelectionBox: _propTypes2.default.object
};

Selection.defaultProps = {
  enabled: true,
  onSelectionChange: (0, _always2.default)(undefined),
  sensibility: -1,
  styleSelectionBox: {
    background: 'rgba(0, 162, 255, 0.4)'
  }

  /*
   *
   *
   *
   *
   * ~~~ SelectionItem
   *
   */
};
var SelectionItem = function (_Component2) {
  _inherits(SelectionItem, _Component2);

  function SelectionItem(props) {
    _classCallCheck(this, SelectionItem);

    var _this2 = _possibleConstructorReturn(this, (SelectionItem.__proto__ || Object.getPrototypeOf(SelectionItem)).call(this, props));

    _this2.state = {};
    return _this2;
  }

  _createClass(SelectionItem, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.state.isSelected !== nextState.isSelected;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          children = _props.children,
          other = _objectWithoutProperties(_props, ['className', 'children']);

      if (this.state.isSelected) className += ' rds-item--selected';
      return _react2.default.createElement(
        'div',
        _extends({ className: className }, other),
        children
      );
    }
  }]);

  return SelectionItem;
}(_react.Component);

/*
 *
 *
 *
 *
 * ~~~ export
 *
 */


exports.Selection = Selection;
exports.SelectionItem = SelectionItem;